/*
 * This file belongs to FreeMiNT. It's not in the original MiNT 1.12
 * distribution. See the file CHANGES for a detailed log of changes.
 * 
 * 
 * Copyright 2000 Frank Naumann <fnaumann@freemint.de>
 * All rights reserved.
 * 
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * 
 * Author: Frank Naumann <fnaumann@freemint.de>
 * Started: 2000-10-08
 * 
 * Please send suggestions, patches or bug reports to me or
 * the MiNT mailing list.
 * 
 */

# ifndef _mint_m68k_register_h
# define _mint_m68k_register_h


/*
 * structure used as 3rd argument to Ptrace(PT_GETREGS/PT_SETREGS)
 */
struct reg
{
	long	regs[16];	/* D0-D7/A0-A7 */
	long	sr;
	long	pc;
};

/*
 * structure used as 3rd argument to Ptrace(PT_GETFPREGS/PT_SETFPREGS)
 */
struct fpreg
{
	long	regs[8][3];	/* FP0-FP7 */
	long	fpcr;
	long	fpsr;
	long	fpiar;
};


# endif /* _mint_m68k_register_h */
